/*********************************************************************
 *
 *  $Id: svn_id $
 *
 *  Implements YAirQualityProxy, the Proxy API for AirQuality
 *
 *  - - - - - - - - - License information: - - - - - - - - -
 *
 *  Copyright (C) 2011 and beyond by Yoctopuce Sarl, Switzerland.
 *
 *  Yoctopuce Sarl (hereafter Licensor) grants to you a perpetual
 *  non-exclusive license to use, modify, copy and integrate this
 *  file into your software for the sole purpose of interfacing
 *  with Yoctopuce products.
 *
 *  You may reproduce and distribute copies of this file in
 *  source or object form, as long as the sole purpose of this
 *  code is to interface with Yoctopuce products. You must retain
 *  this notice in the distributed source file.
 *
 *  You should refer to Yoctopuce General Terms and Conditions
 *  for additional information regarding your rights and
 *  obligations.
 *
 *  THE SOFTWARE AND DOCUMENTATION ARE PROVIDED 'AS IS' WITHOUT
 *  WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING
 *  WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY, FITNESS
 *  FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO
 *  EVENT SHALL LICENSOR BE LIABLE FOR ANY INCIDENTAL, SPECIAL,
 *  INDIRECT OR CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA,
 *  COST OF PROCUREMENT OF SUBSTITUTE GOODS, TECHNOLOGY OR
 *  SERVICES, ANY CLAIMS BY THIRD PARTIES (INCLUDING BUT NOT
 *  LIMITED TO ANY DEFENSE THEREOF), ANY CLAIMS FOR INDEMNITY OR
 *  CONTRIBUTION, OR OTHER SIMILAR COSTS, WHETHER ASSERTED ON THE
 *  BASIS OF CONTRACT, TORT (INCLUDING NEGLIGENCE), BREACH OF
 *  WARRANTY, OR OTHERWISE.
 *
 *********************************************************************/


using System;
using System.Collections.Generic;
using System.IO;
using System.Threading;
using System.Timers;
using System.Globalization;
using System.Text.RegularExpressions;
using YoctoLib;

namespace YoctoProxyAPI
{
    //--- (YAirQuality class start)
    static public partial class YoctoProxyManager
    {
        public static YAirQualityProxy FindAirQuality(string name)
        {
            // cases to handle:
            // name =""  no matching unknwn
            // name =""  unknown exists
            // name != "" no  matching unknown
            // name !="" unknown exists
            YAirQuality func = null;
            YAirQualityProxy res = (YAirQualityProxy)YFunctionProxy.FindSimilarUnknownFunction("YAirQualityProxy");

            if (name == "") {
                if (res != null) return res;
                res = (YAirQualityProxy)YFunctionProxy.FindSimilarKnownFunction("YAirQualityProxy");
                if (res != null) return res;
                func = YAirQuality.FirstAirQuality();
                if (func != null) {
                    name = func.get_hardwareId();
                    if (func.get_userData() != null) {
                        return (YAirQualityProxy)func.get_userData();
                    }
                }
            } else {
                func = YAirQuality.FindAirQuality(name);
                if (func.get_userData() != null) {
                    return (YAirQualityProxy)func.get_userData();
                }
            }
            if (res == null) {
                res = new YAirQualityProxy(func, name);
            }
            if (func != null) {
                res.linkToHardware(name);
                if(func.isOnline()) res.arrival();
            }
            return res;
        }
    }

/**
 * <summary>
 *   The <c>YAirQuality</c> class allows you to read and configure Yoctopuce air quality sensors.
 * <para>
 *   It inherits from <c>YSensor</c> class the core functions to read measurements,
 *   to register callback functions, and to access the autonomous datalogger.
 * </para>
 * <para>
 * </para>
 * </summary>
 */
    public class YAirQualityProxy : YSensorProxy
    {
        /**
         * <summary>
         *   Retrieves a air quality sensor for a given identifier.
         * <para>
         *   The identifier can be specified using several formats:
         * </para>
         * <para>
         * </para>
         * <para>
         *   - FunctionLogicalName
         * </para>
         * <para>
         *   - ModuleSerialNumber.FunctionIdentifier
         * </para>
         * <para>
         *   - ModuleSerialNumber.FunctionLogicalName
         * </para>
         * <para>
         *   - ModuleLogicalName.FunctionIdentifier
         * </para>
         * <para>
         *   - ModuleLogicalName.FunctionLogicalName
         * </para>
         * <para>
         * </para>
         * <para>
         *   This function does not require that the air quality sensor is online at the time
         *   it is invoked. The returned object is nevertheless valid.
         *   Use the method <c>YAirQuality.isOnline()</c> to test if the air quality sensor is
         *   indeed online at a given time. In case of ambiguity when looking for
         *   a air quality sensor by logical name, no error is notified: the first instance
         *   found is returned. The search is performed first by hardware name,
         *   then by logical name.
         * </para>
         * <para>
         *   If a call to this object's is_online() method returns FALSE although
         *   you are certain that the matching device is plugged, make sure that you did
         *   call registerHub() at application initialization time.
         * </para>
         * <para>
         * </para>
         * </summary>
         * <param name="func">
         *   a string that uniquely characterizes the air quality sensor, for instance
         *   <c>MyDevice.airQuality</c>.
         * </param>
         * <returns>
         *   a <c>YAirQuality</c> object allowing you to drive the air quality sensor.
         * </returns>
         */
        public static YAirQualityProxy FindAirQuality(string func)
        {
            return YoctoProxyManager.FindAirQuality(func);
        }
        //--- (end of YAirQuality class start)
        //--- (YAirQuality definitions)
        public const double _UbaIndex_INVALID = Double.NaN;
        public const double _RelativeIndex_INVALID = Double.NaN;
        public const int _AqiMode_INVALID = 0;
        public const int _AqiMode_RELATIVE = 1;
        public const int _AqiMode_UBA = 2;

        // reference to real YoctoAPI object
        protected new YAirQuality _func;
        // property cache
        protected int _aqiMode = _AqiMode_INVALID;
        //--- (end of YAirQuality definitions)

        //--- (YAirQuality implementation)
        internal YAirQualityProxy(YAirQuality hwd, string instantiationName) : base(hwd, instantiationName)
        {
            InternalStuff.log("AirQuality " + instantiationName + " instantiation");
            base_init(hwd, instantiationName);
        }

        // perform the initial setup that may be done without a YoctoAPI object (hwd can be null)
        internal override void base_init(YFunction hwd, string instantiationName)
        {
            _func = (YAirQuality) hwd;
           	base.base_init(hwd, instantiationName);
        }

        // link the instance to a real YoctoAPI object
        internal override void linkToHardware(string hwdName)
        {
            YAirQuality hwd = YAirQuality.FindAirQuality(hwdName);
            // first redo base_init to update all _func pointers
            base_init(hwd, hwdName);
            // then setup Yocto-API pointers and callbacks
            init(hwd);
        }

        // perform the 2nd stage setup that requires YoctoAPI object
        protected void init(YAirQuality hwd)
        {
            if (hwd == null) return;
            base.init(hwd);
            InternalStuff.log("registering AirQuality callback");
            _func.registerValueCallback(valueChangeCallback);
        }

        /**
         * <summary>
         *   Enumerates all functions of type AirQuality available on the devices
         *   currently reachable by the library, and returns their unique hardware ID.
         * <para>
         *   Each of these IDs can be provided as argument to the method
         *   <c>YAirQuality.FindAirQuality</c> to obtain an object that can control the
         *   corresponding device.
         * </para>
         * </summary>
         * <returns>
         *   an array of strings, each string containing the unique hardwareId
         *   of a device function currently connected.
         * </returns>
         */
        public static new string[] GetSimilarFunctions()
        {
            List<string> res = new List<string>();
            YAirQuality it = YAirQuality.FirstAirQuality();
            while (it != null)
            {
                res.Add(it.get_hardwareId());
                it = it.nextAirQuality();
            }
            return res.ToArray();
        }

        protected override void functionArrival()
        {
            base.functionArrival();
        }

        protected override void moduleConfigHasChanged()
       	{
            base.moduleConfigHasChanged();
            _aqiMode = _func.get_aqiMode()+1;
        }

        /**
         * <summary>
         *   Returns the current air quality index, according to UBA (from 1 to 5).
         * <para>
         * </para>
         * <para>
         * </para>
         * </summary>
         * <returns>
         *   a floating point number corresponding to the current air quality index, according to UBA (from 1 to 5)
         * </returns>
         * <para>
         *   On failure, throws an exception or returns <c>YAirQuality.UBAINDEX_INVALID</c>.
         * </para>
         */
        public double get_ubaIndex()
        {
            double res;
            if (_func == null) {
                throw new YoctoApiProxyException("No AirQuality connected");
            }
            res = _func.get_ubaIndex();
            if (res == YAPI.INVALID_DOUBLE) {
                res = Double.NaN;
            }
            return res;
        }

        /**
         * <summary>
         *   Returns the relative air quality index, according to ScioSense (from 0 to 500).
         * <para>
         *   A value below 100 indicates better-than-average air quality compared to the past 24 hours,
         *   while a value above 100 indicates poorer-than-average air quality compared to the past 24 hours.
         * </para>
         * <para>
         * </para>
         * </summary>
         * <returns>
         *   a floating point number corresponding to the relative air quality index, according to ScioSense (from 0 to 500)
         * </returns>
         * <para>
         *   On failure, throws an exception or returns <c>YAirQuality.RELATIVEINDEX_INVALID</c>.
         * </para>
         */
        public double get_relativeIndex()
        {
            double res;
            if (_func == null) {
                throw new YoctoApiProxyException("No AirQuality connected");
            }
            res = _func.get_relativeIndex();
            if (res == YAPI.INVALID_DOUBLE) {
                res = Double.NaN;
            }
            return res;
        }

        /**
         * <summary>
         *   Returns the type of index reported by the get_currentValue function and callbacks (UBA index or relative index).
         * <para>
         * </para>
         * <para>
         * </para>
         * </summary>
         * <returns>
         *   either <c>YAirQuality.AQIMODE_RELATIVE</c> or <c>YAirQuality.AQIMODE_UBA</c>, according to the type
         *   of index reported by the get_currentValue function and callbacks (UBA index or relative index)
         * </returns>
         * <para>
         *   On failure, throws an exception or returns <c>YAirQuality.AQIMODE_INVALID</c>.
         * </para>
         */
        public int get_aqiMode()
        {
            if (_func == null) {
                throw new YoctoApiProxyException("No AirQuality connected");
            }
            // our enums start at 0 instead of the 'usual' -1 for invalid
            return _func.get_aqiMode()+1;
        }

        /**
         * <summary>
         *   Changes the the type of index reported by the get_currentValue function and callbacks (UBA index or relative index).
         * <para>
         *   Remember to call the <c>saveToFlash()</c> method of the module if the modification must be kept.
         * </para>
         * <para>
         * </para>
         * </summary>
         * <param name="newval">
         *   either <c>YAirQuality.AQIMODE_RELATIVE</c> or <c>YAirQuality.AQIMODE_UBA</c>, according to the the
         *   type of index reported by the get_currentValue function and callbacks (UBA index or relative index)
         * </param>
         * <para>
         * </para>
         * <returns>
         *   <c>0</c> if the call succeeds.
         * </returns>
         * <para>
         *   On failure, throws an exception or returns a negative error code.
         * </para>
         */
        public int set_aqiMode(int newval)
        {
            if (_func == null) {
                throw new YoctoApiProxyException("No AirQuality connected");
            }
            if (newval == _AqiMode_INVALID) {
                return YAPI.SUCCESS;
            }
            // our enums start at 0 instead of the 'usual' -1 for invalid
            return _func.set_aqiMode(newval-1);
        }

        // property with cached value for instant access (configuration)
        /// <value>Type of index reported by the get_currentValue function and callbacks (UBA index or relative index).</value>
        public int AqiMode
        {
            get
            {
                if (_func == null) {
                    return _AqiMode_INVALID;
                }
                if (_online) {
                    return _aqiMode;
                }
                return _AqiMode_INVALID;
            }
            set
            {
                setprop_aqiMode(value);
            }
        }

        // private helper for magic property
        private void setprop_aqiMode(int newval)
        {
            if (_func == null) {
                return;
            }
            if (!(_online)) {
                return;
            }
            if (newval == _AqiMode_INVALID) {
                return;
            }
            if (newval == _aqiMode) {
                return;
            }
            // our enums start at 0 instead of the 'usual' -1 for invalid
            _func.set_aqiMode(newval-1);
            _aqiMode = newval;
        }
    }
    //--- (end of YAirQuality implementation)
}

